#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaNon1"]
#Text["Contest Marisa's first nonspell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"

let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let ImageFam = GetCurrentScriptDirectory ~ "IMG/Familiar.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;

@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjMove_SetPosition(Boss,GetStgFrameWidth/2+40,-120);
	ObjMove_SetDestAtFrame(Boss,GetStgFrameWidth/2,100,60);
	ObjTempInv(Boss,240);
	FamAndPath1;
	Ending;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	Timing++;
	if (Timing == 300) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3+rand(-50,50),rand(80,140),20,7);}
    if (Timing == 600) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3*2+rand(-50,50),rand(80,140),20,7);}
	if (Timing == 900) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2+rand(-100,100),rand(140,170),20,7); Timing = 0;}
	yield;

}

function wait(w) { loop(w) { yield; } }

task ObjTempInv(Obj,time) {
	ObjEnemy_SetDamageRate(Obj,0,0);
	wait(time);
	ObjEnemy_SetDamageRate(Obj,80,50);
}

task RenderMarisa {
let dir;
let speed;

ObjPrim_SetTexture(Boss,ImageBoss);
ObjSprite2D_SetDestCenter(Boss); 
ObjRender_SetScaleXYZ(Boss,1,1,0);
MagicCircle;

ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
ObjAnim_StartAnimationA1(Boss, 5, 3);
}
 
task MagicCircle{
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
	Obj_Delete(Circle);
}
 
task RotateImg(obj,speed) {
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=speed;
		ObjRender_SetAngleZ(obj,count);
		if (count == speed*360) {count = 0;}
		yield;
	}
}	
 
task FamAndPath1 { //Creates 8 familiars and sends them on their way lingering around the boss
	wait(150);
	PlaySoundInSingle("se_effect_glub");
	let obj = [];
	let count = 0;
	let count2 = 180;
	ascent(m in 0..8) { //number of familiars, and number to add to the array
		obj = append(obj,ObjEnemy_Create(OBJ_ENEMY)); //add an enemy to the array
        ObjMove_SetPosition(obj[m],BossX,BossY); //sets the position of the objs at the boss
        ObjPrim_SetTexture(obj[m],ImageFam); //Gives the enemy an image
        ObjSprite2D_SetSourceRect(obj[m],0,0,72,72); //gives the enemy the exact box the graphic you want from the image is
        ObjSprite2D_SetDestCenter(obj[m]); //sets the center of the obj
        ObjEnemy_Regist(obj[m]); //registers the enemy
		ObjRender_SetScaleXYZ(obj[m],0.6,0.6,0); //sets the size of the enemy image, 1 is normal size
		RotateImg(obj[m],4);
		fire(obj[m],m);
	}
	let incr =30;
	wait(1);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		if (incr >= 5) {incr -=0.3;}
		count+=2;
		count2+=2;
		ObjMove_SetDestAtWeight(obj[0],BossX+100*cos(count),BossY+100*sin(-count*0.5),incr,30);
		ObjMove_SetDestAtWeight(obj[1],BossX-100*cos(count),BossY+100*sin(count*0.5),incr,30);
		ObjMove_SetDestAtWeight(obj[2],BossX-100*cos(count2*0.5),BossY-100*cos(count2),incr,30);
		ObjMove_SetDestAtWeight(obj[3],BossX+100*cos(count2*0.5),BossY+100*cos(-count2),incr,30);
		ObjMove_SetDestAtWeight(obj[4],BossX-50*cos(count),BossY+50*sin(-count*0.5),incr,30);
		ObjMove_SetDestAtWeight(obj[5],BossX+50*cos(count),BossY+50*sin(count*0.5),incr,30);
		ObjMove_SetDestAtWeight(obj[6],BossX+50*cos(count2*0.5),BossY-50*cos(count2),incr,30);
		ObjMove_SetDestAtWeight(obj[7],BossX-50*cos(count2*0.5),BossY+50*cos(-count2),incr,30);
		wait(1);
		if (count == 720) {count = 0}
		if (count2 == 900) {count2 = 180}
	}
	ascent(m in 0..8) {Obj_Delete(obj[m]); }
}

task PlaySoundInSingle(name){
 NotifyEvent(GetCommonData("MarisaBossPlural.cs", ID_INVALID), EV_USER+20, name);
}

task fire(obj,col) {
	wait(120);
	let count = 0;
	let dir = 0+col*45;
	let skip = 0;
	while (!Obj_IsDeleted(obj)) {
		count+=10;
		PlaySoundInSingle("se_shot_tan00");
		ascent(i in 0..2) { //used to be just a loop, changed to make bullets move different speeds
			let objY = ObjMove_GetY(obj);
			let objX = ObjMove_GetX(obj);
			dir+=360/2;
			if (col >= 3) {skip = 1;}
			CreateShotA1(objX,objY,2-i*0.5,dir+count+col*5,34+col+skip,20);
		}
	wait(13);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	CloseScript(GetOwnScriptID());
}