#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaNon2"]
#Text["Contest Marisa's ??? nonspell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"

let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let ImageFam = GetCurrentScriptDirectory ~ "IMG/Familiar.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;

@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjTempInv(Boss,200);
	FamAndPath2;
	Ending;

}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	Timing++;
	if (Timing == 100) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3+rand(-50,50),rand(80,140),20,10);}
	if (Timing == 200) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2+rand(-50,50),rand(80,140),20,10);}
    if (Timing == 300) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3*2+rand(-50,50),rand(80,140),20,10);}
	if (Timing == 400) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2+rand(-50,50),rand(80,140),20,10);}
	if (Timing == 500) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3+rand(-50,50),rand(80,140),20,10);}
	if (Timing == 600) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2+rand(-50,50),rand(80,140),20,10);}
	if (Timing == 700) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3*2+rand(-50,50),rand(80,140),20,10);}
	if (Timing == 800) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2+rand(-50,50),rand(80,140),20,10); Timing = 0;}
	yield;

}

function wait(w) { loop(w) { yield; } }

task ObjTempInv(Obj,time) {
	ObjEnemy_SetDamageRate(Obj,0,0);
	wait(time);
	ObjEnemy_SetDamageRate(Obj,80,50);
}

task RenderMarisa {
 let dir;
 let speed;

 ObjPrim_SetTexture(Boss,ImageBoss);
 ObjSprite2D_SetDestCenter(Boss); 
 ObjRender_SetScaleXYZ(Boss,1,1,0);
 MagicCircle;

 ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
 ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
 descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

 ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
 ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
 ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
 ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
 ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
 ObjAnim_StartAnimationA1(Boss, 5, 3);
 }
 
 task MagicCircle{
	wait(1);
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
	Obj_Delete(Circle);
}
 
task RotateImg(obj,speed) {
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=speed;
		ObjRender_SetAngleZ(obj,count);
		if (count == speed*360) {count = 0;}
		yield;
	}
}	

task PlaySoundInSingle(name){
 NotifyEvent(GetCommonData("MarisaBossPlural.cs", ID_INVALID), EV_USER+20, name);
}

task FamAndPath2 {
	wait(120);
	PlaySoundInSingle("se_effect_glub");
	let obj = [];
	let count = 0;
	ascent(m in 0..10) {
		obj = append(obj,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(obj[m],BossX,BossY);
        ObjPrim_SetTexture(obj[m],ImageFam);
        ObjSprite2D_SetSourceRect(obj[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(obj[m]);
        ObjEnemy_Regist(obj[m]);
		ObjRender_SetScaleXYZ(obj[m],0.6,0.6,0);
		RotateImg(obj[m],-4);
		shoot(obj[m],m*10,m);
	}
	wait(1);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjMove_SetDestAtWeight(obj[0],BossX+105*cos(count),BossY+100*sin(count),30,30);
		ObjMove_SetDestAtWeight(obj[1],BossX+110*cos(count+36),BossY+100*sin(count+36*3),30,5);
		ObjMove_SetDestAtWeight(obj[2],BossX+115*cos(count+72),BossY+100*sin(count+72*3),30,5);
		ObjMove_SetDestAtWeight(obj[3],BossX+120*cos(count+108),BossY+100*sin(count+108*3),30,5);
		ObjMove_SetDestAtWeight(obj[4],BossX+125*cos(count+144),BossY+100*sin(count+144*3),30,5);
		ObjMove_SetDestAtWeight(obj[5],BossX+130*cos(count+180),BossY+100*sin(count+180*3),30,5);
		ObjMove_SetDestAtWeight(obj[6],BossX+135*cos(count+216),BossY+100*sin(count+216*3),30,5);
		ObjMove_SetDestAtWeight(obj[7],BossX+140*cos(count+252),BossY+100*sin(count+252*3),30,5);
		ObjMove_SetDestAtWeight(obj[8],BossX+145*cos(count+288),BossY+100*sin(count+288*3),30,5);
		ObjMove_SetDestAtWeight(obj[9],BossX+150*cos(count+324),BossY+100*sin(count+324*3),30,5);
		wait(1);
		if (count == 360) {count = 0}
	}
	ascent(i in 0..10) {Obj_Delete(obj[i]);}
}

task shoot(obj,dir,col) {
	wait(120+dir*3);
	let count = 0;
	let flip = 0+col*10;
	while(!Obj_IsDeleted(obj)) {
		PlaySoundInSingle("se_shot_tan00");
		ascent(i in 0..2) {
			let objY = ObjMove_GetY(obj);
			let objX = ObjMove_GetX(obj);
			count+=20;
			loop(col+1) {
				flip+=360/(col+1);
				CreateShotA1(objX,objY,1.5+col*0.1,flip+count,34+col,20);
			}
		if (count == 20*360) {count = 0;}
		}
		wait(13+dir);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	CloseScript(GetOwnScriptID());
}