#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaNon3"]
#Text["Contest Marisa's ??? nonspell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"

let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let ImageFam = GetCurrentScriptDirectory ~ "IMG/Familiar.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;

@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjMove_SetPosition(Boss,GetStgFrameWidth/2+40,-120);
	ObjMove_SetDestAtFrame(Boss,GetStgFrameWidth/2,100,60);
	FamAndPath3;
	FamAndPath4;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	Timing++;
	if (Timing == 170) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3+rand(-100,100),rand(80,140),20,7);}
    if (Timing == 350) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/3*2+rand(-100,100),rand(80,140),20,7);}
	if (Timing == 360) {Timing = 0;}
	yield;

}

function wait(w) { loop(w) { yield; } }

task RenderMarisa {
 let dir;
 let speed;

 ObjPrim_SetTexture(Boss,ImageBoss);
 ObjSprite2D_SetDestCenter(Boss); 
 ObjRender_SetScaleXYZ(Boss,1,1,0);
 MagicCircle;

 ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
 ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
 descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

 ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
 ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
 ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
 ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
 ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
 ObjAnim_StartAnimationA1(Boss, 5, 3,0,180);
 }
 
 task MagicCircle{
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
}
 
task RotateImg(obj,speed) {
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=speed;
		ObjRender_SetAngleZ(obj,count);
		if (count == speed*360) {count = 0;}
		yield;
	}
}

task FamAndPath3 {
	wait(120);
	let obj = [];
	let count = 0;
	ascent(m in 0..8) { 
		obj = append(obj,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(obj[m],BossX,BossY);
        ObjPrim_SetTexture(obj[m],ImageFam);
        ObjSprite2D_SetSourceRect(obj[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(obj[m]);
        ObjEnemy_Regist(obj[m]);
		ObjRender_SetScaleXYZ(obj[m],0.6,0.6,0);
		RotateImg(obj[m],4);
		firedown(obj[m],m);
	}
	wait(1);
	let incr = 30;
	while(!Obj_IsDeleted(obj)) {
		count+=1;
		if (incr >= 5) {incr -=0.3;}
		ObjMove_SetDestAtWeight(obj[0],BossX+160*cos(count*3),BossY+120*sin(count*5),incr,30);
		ObjMove_SetDestAtWeight(obj[1],BossX+160*cos((count+5)*3),BossY+120*sin((count+5)*5),incr,30);
		ObjMove_SetDestAtWeight(obj[2],BossX+160*cos((count+10)*3),BossY+120*sin((count+10)*5),incr,30);
		ObjMove_SetDestAtWeight(obj[3],BossX+160*cos((count+15)*3),BossY+120*sin((count+15)*5),incr,30);
		ObjMove_SetDestAtWeight(obj[4],BossX+160*cos((count+180)*3),BossY+120*sin((count+180)*5),incr,30);
		ObjMove_SetDestAtWeight(obj[5],BossX+160*cos((count+185)*3),BossY+120*sin((count+185)*5),incr,30);
		ObjMove_SetDestAtWeight(obj[6],BossX+160*cos((count+190)*3),BossY+120*sin((count+190)*5),incr,30);
		ObjMove_SetDestAtWeight(obj[7],BossX+160*cos((count+195)*3),BossY+120*sin((count+195)*5),incr,30);
		wait(1);
		if (count == 360) {count = 0}
	}
}
task FamAndPath4 {
	wait(120);
	let obj = [];
	let count = 0;
	let flux;
	ascent(m in 0..8) {
		obj = append(obj,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(obj[m],BossX,BossY);
        ObjPrim_SetTexture(obj[m],ImageFam);
        ObjSprite2D_SetSourceRect(obj[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(obj[m]);
        ObjEnemy_Regist(obj[m]);
		ObjRender_SetScaleXYZ(obj[m],0.6,0.6,0);
		RotateImg(obj[m],-4);
		fireshoot(obj[m],m);
	}
	wait(1);
	let incr = 30;
	while(!Obj_IsDeleted(obj)) {
		count+=1;
		if (incr >= 5) {incr -=0.3;}
		flux = 50*sin(count);
		ObjMove_SetDestAtWeight(obj[0],BossX+80*cos(count+flux),BossY+80*sin(count+flux),incr,30);
		ObjMove_SetDestAtWeight(obj[1],BossX+80*cos((count+90+flux)),BossY+80*sin((count+90+flux)),incr,30);
		ObjMove_SetDestAtWeight(obj[2],BossX+80*cos((count+180+flux)),BossY+80*sin((count+180+flux)),incr,30);
		ObjMove_SetDestAtWeight(obj[3],BossX+80*cos((count+270+flux)),BossY+80*sin((count+270+flux)),incr,30);
		ObjMove_SetDestAtWeight(obj[4],BossX+80*cos((count+45+flux)),BossY+80*sin((count+45+flux)),incr,30);
		ObjMove_SetDestAtWeight(obj[5],BossX+80*cos((count+135+flux)),BossY+80*sin((count+135+flux)),incr,30);
		ObjMove_SetDestAtWeight(obj[6],BossX+80*cos((count+225+flux)),BossY+80*sin((count+225+flux)),incr,30);
		ObjMove_SetDestAtWeight(obj[7],BossX+80*cos((count+315+flux)),BossY+80*sin((count+315+flux)),incr,30);
		wait(1);
		if (count == 360) {count = 0}
	}
}
		
task fireshoot(obj,col) {
	wait(120);
	let count = 0;
	while(!Obj_IsDeleted(obj)) {
		let spread = -20;
		ascent(i in 0..3) {
			spread+=20;
			count++;
			let objY = ObjMove_GetY(obj);
			let objX = ObjMove_GetX(obj);
			CreateShotA1(objX,objY,1.5-i*0.2,ObjMove_GetAngle(obj)+spread+count*10,35+col,30);
		}
	wait(37);
	}
}

task firedown(obj,delay) {
	wait(480);
	while(!Obj_IsDeleted(obj)) {
		let objY = ObjMove_GetY(obj);
		let objX = ObjMove_GetX(obj);
		let dir = -2.5;
		loop(2) {
			dir+=5;
			CreateShotA2(objX,objY,7,ObjMove_GetAngle(obj)+dir,-0.3,2,34,10);
		}
	wait(27);
	}
}

