#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaNon4"]
#Text["Contest Marisa's ??? nonspell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"

let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let ImageFam = GetCurrentScriptDirectory ~ "IMG/Familiar.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;

@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjMove_SetDestAtFrame(Boss,GetStgFrameWidth/2,100,60);
	ObjTempInv(Boss,200);
	FamAndPath5;
	Ending;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(3500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	yield;

}

function wait(w) { loop(w) { yield; } }

task ObjTempInv(Obj,time) {
	ObjEnemy_SetDamageRate(Obj,0,0);
	wait(time);
	ObjEnemy_SetDamageRate(Obj,80,50);
}

task RenderMarisa {
 let dir;
 let speed;

 ObjPrim_SetTexture(Boss,ImageBoss);
 ObjSprite2D_SetDestCenter(Boss); 
 ObjRender_SetScaleXYZ(Boss,1,1,0);
 MagicCircle;

 ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
 ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
 descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

 ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
 ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
 ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
 ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
 ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
 ObjAnim_StartAnimationA1(Boss, 5, 3);
 }
 
 task MagicCircle{
	wait(1);
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
	Obj_Delete(Circle);
}
 
task RotateImg(obj,speed) {
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=speed;
		ObjRender_SetAngleZ(obj,count);
		if (count == speed*360) {count = 0;}
		yield;
	}
}	

task FamAndPath5 { //Creates 10 familiars and sends them on their way lingering around the boss
	wait(120);
	PlaySoundInSingle("se_effect_glub");
	let obj = [];
	let count = 0;
	ascent(m in 0..10) { //number of familiars, and number to add to the array
		obj = append(obj,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(obj[m],BossX,BossY);
        ObjPrim_SetTexture(obj[m],ImageFam);
        ObjSprite2D_SetSourceRect(obj[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(obj[m]);
        ObjEnemy_Regist(obj[m]);
		ObjRender_SetScaleXYZ(obj[m],0.6,0.6,0);
		RotateImg(obj[m],-4);
		fireshootshootfire(obj[m],m);
		
	}
	wait(1);
	let incr = 20;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=1;
		if (incr >= 1) {incr -=0.3;}
		ObjMove_SetDestAtWeight(obj[0],BossX+30*cos(count),BossY+30*sin(count),incr,30); //used to +80 +80 on all
		ObjMove_SetDestAtWeight(obj[1],BossX+40*cos(count*1.5),BossY+40*sin(count*1.5),incr,30);
		ObjMove_SetDestAtWeight(obj[2],BossX+50*cos(count*2),BossY+50*sin(count*2),incr,30);
		ObjMove_SetDestAtWeight(obj[3],BossX+60*cos(count*2.5),BossY+60*sin(count*2.5),incr,30);
		ObjMove_SetDestAtWeight(obj[4],BossX+70*cos(count*3),BossY+70*sin(count*3),incr,30);
		ObjMove_SetDestAtWeight(obj[5],BossX+80*cos(count*3.5),BossY+80*sin(count*3.5),incr,30);
		ObjMove_SetDestAtWeight(obj[6],BossX+90*cos(count*4),BossY+90*sin(count*4),incr,30);
		ObjMove_SetDestAtWeight(obj[7],BossX+100*cos(count*4.5),BossY+100*sin(count*4.5),incr,30);
		ObjMove_SetDestAtWeight(obj[8],BossX+110*cos(count*5),BossY+110*sin(count*5),incr,30);
		ObjMove_SetDestAtWeight(obj[9],BossX+120*cos(count*5.5),BossY+120*sin(count*5.5),incr,30);

		wait(1);
		if (count == 720) {count = 0}
	}
	ascent(i in 0..10) {Obj_Delete(obj[i]);}
}

task PlaySoundInSingle(name){
	NotifyEvent(GetCommonData("MarisaBossPlural.cs", ID_INVALID), EV_USER+20, name);
}

task fireshootshootfire(obj,col) {
	wait(120);
	let count = 0;
	let flux = 0;
	let dir = 0;
	while (!Obj_IsDeleted(obj)) {
			PlaySoundInSingle("se_shot_tan01");
			count+=2;
			dir+=360/10;
			flux = 45*sin(count+col);
			let objY = ObjMove_GetY(obj);
			let objX = ObjMove_GetX(obj);
			CreateShotA2(objX,objY,1,ObjMove_GetAngle(obj)+dir+flux+count,0.1,3.5+(col*0.1),34+col,20); //used to be 4-(col*0.1) in max speed

	wait(6);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	CloseScript(GetOwnScriptID());
}