#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaSpell1"]
#Text["Contest Marisa's first spell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"
#include"./GTcutin.txt"


//Light Conversion "Aurora to Moonlight"
let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let ImageFam = GetCurrentScriptDirectory ~ "IMG/Familiar.png";
let ImageSpellBG = GetCurrentScriptDirectory ~ "IMG/Hakkero3.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;
let fam = [];
let Spark;

@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	SpellBG;
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjCutin_SetSpellcardS3("Light Conversion \"Aurora To Moonlight\"", 0, 255, 128);
	ObjCutin_LaunchS3("NAZRIN",GetCurrentScriptDirectory~"IMG/DairiMarisa.png","Lunatic");
	Spell;
	ObjTempInv(Boss,200);
	FamCreate(4,30,1.5,74);
	MoveMarisa;
	Ending;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(4500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(90);
	}
	
	case(EV_REQUEST_SPELL_SCORE) {
		SetScriptResult(70000);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	if (ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 3500){Timing++;}
	if (ObjEnemy_GetInfo(Boss, INFO_LIFE) < 3500){Timing+=1.25;}
	if (ObjEnemy_GetInfo(Boss, INFO_LIFE) < 2500){Timing+=1.5;}
	if (Timing >= 800) {Timing = 0; comet(rand(30,GetStgFrameWidth-30),-40); }
	yield;

}

task Spell {
let objScene = GetEnemyBossSceneObjectID;
ObjEnemyBossScene_StartSpell(objScene);
}

function wait(w) { loop(w) { yield; } }

task ObjTempInv(Obj,time) {
	ObjEnemy_SetDamageRate(Obj,0,0);
	wait(time);
	ObjEnemy_SetDamageRate(Obj,80,50);
}

task RenderMarisa {
let dir;
let speed;

ObjPrim_SetTexture(Boss,ImageBoss);
ObjSprite2D_SetDestCenter(Boss); 
ObjRender_SetScaleXYZ(Boss,1,1,0);
MagicCircle;

ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
ObjAnim_StartAnimationA1(Boss, 5, 3);
}

 
task SpellBG {
	let SpellBGobj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(SpellBGobj,ImageSpellBG);
	ObjSprite2D_SetSourceRect(SpellBGobj,0,0,800,800);
	ObjSprite2D_SetDestRect(SpellBGobj,0,0,800,800);
	Obj_SetRenderPriorityI(SpellBGobj,22);
	ObjSprite2D_SetDestCenter(SpellBGobj); 
	ObjRender_SetPosition(SpellBGobj,GetStgFrameWidth/2,GetStgFrameHeight/2,0);
	let count = 0;
	ObjRender_SetAlpha(SpellBGobj,128);
	ObjRender_SetScaleXYZ(SpellBGobj,0.6,0.6,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=0.5;
		ObjRender_SetAngleZ(SpellBGobj,-count);
		yield;
		if (count == 360) {count = 0; }
	}
	Obj_Delete(SpellBGobj);
 }
 
task MagicCircle{
	wait(1);
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
	Obj_Delete(Circle);
}
 
task RotateImg(obj,speed) {
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=speed;
		ObjRender_SetAngleZ(obj,count);
		if (count == speed*360) {count = 0;}
		yield;
	}
}

task MoveMarisa {
	wait(90);
	let count = 0;
	let incr = 30;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count++;
		if (incr >= 5) {incr -=0.3;}
		ObjMove_SetDestAtWeight(Boss,(GetStgFrameWidth/2)+120*cos(count),70+40*sin(count),incr,5);
		if (count == 360) {count = 0;}
		yield;
	}
}

task FamCreate(amt,Y,speed,delay) {
	let countstart = rand(0,360);
	PlaySoundInSingle("se_effect_glub");
	ascent(m in 0..4) { 
		fam = append(fam,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(fam[m],-30,Y);
        ObjPrim_SetTexture(fam[m],ImageFam);
        ObjSprite2D_SetSourceRect(fam[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(fam[m]);
        ObjEnemy_Regist(fam[m]);
		ObjRender_SetScaleXYZ(fam[m],0.6,0.6,0);
		RotateImg(fam[m],3);
		MoveFam(fam[m],Y,GetStgFrameWidth+60,1.5,1);
		wait(delay);
		Fire(fam[m],50,70,1.4,countstart);
	}
		ascent(m in 4..8) { 
		fam = append(fam,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(fam[m],GetStgFrameWidth+30,Y+70);
        ObjPrim_SetTexture(fam[m],ImageFam);
        ObjSprite2D_SetSourceRect(fam[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(fam[m]);
        ObjEnemy_Regist(fam[m]);
		ObjRender_SetScaleXYZ(fam[m],0.6,0.6,0);
		RotateImg(fam[m],3);
		MoveFam(fam[m],Y+50,GetStgFrameWidth+60,1.5,0);
		wait(delay);
		Fire(fam[m],50,60,1.2,countstart);
	}
		ascent(m in 8..11) { 
		fam = append(fam,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(fam[m],-30,Y+140);
        ObjPrim_SetTexture(fam[m],ImageFam);
        ObjSprite2D_SetSourceRect(fam[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(fam[m]);
        ObjEnemy_Regist(fam[m]);
		ObjRender_SetScaleXYZ(fam[m],0.6,0.6,0);
		RotateImg(fam[m],3);
		MoveFam(fam[m],Y+100,GetStgFrameWidth+60,2,1);
		wait(delay);
		Fire(fam[m],50,50,1,countstart);
	}
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		yield;
	}
	ascent (m in 0..11) {Obj_Delete(fam[m]);}
}

task MoveFam(obj,Y,maxdist,speed,dir) {

	let loc = ObjMove_GetX(obj);
	let count = 0;
	while (!Obj_IsDeleted(obj)) {
		ObjMove_SetDestAtWeight(obj,loc+count,Y,10,5);
		wait(1);
		if (dir == 1) {count+=speed;}
		if (dir == 0) {count-=speed;}
		if (count >= maxdist){count = 0; ObjMove_SetPosition(obj,loc+count,Y);}
		if (count <= -maxdist){count = 0; ObjMove_SetPosition(obj,loc+count,Y);}
	}
}

task Fire(obj,dir,delay,speed,countstart){
	wait(rand(30,60));
	let colorand = rand(37,42);
	let count = countstart;
	let star;
	while (!Obj_IsDeleted(obj)) {
		PlaySoundInSingle("se_shot_tan00");
		count++;
		let flux = 20*sin(count*10);
		let objX = ObjMove_GetX(obj);
		let objY = ObjMove_GetY(obj);
		star = CreateShotA1(objX,objY,speed,90+flux,colorand,30);
		CreateShotA1(objX,objY,speed,270+flux,colorand,30);
		Obj_SetValue(star,"Collide Laser",true);
	wait(delay);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task comet(X,Y) {
	let count = 0;
	let Comet = (ObjEnemy_Create(OBJ_ENEMY));
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
    ObjMove_SetPosition(Comet,X,Y);
    ObjPrim_SetTexture(Comet,ImageFam);
    ObjSprite2D_SetSourceRect(Comet,0,0,72,72);
    ObjSprite2D_SetDestCenter(Comet);
    ObjEnemy_Regist(Comet);
	ObjRender_SetScaleXYZ(Comet,0.6,0.6,0);
	RotateImg(Comet,3);
	let cometX = ObjMove_GetX(Comet);
	let cometY = ObjMove_GetY(Comet);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	ObjMove_SetDestAtWeight(Comet,cometX+rand(-40,40),GetStgFrameHeight,10,3);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) == 0) {Obj_Delete(Comet);}
	let las = Laser_Collider(cometX,cometY,ObjMove_GetAngle(Comet)+180,700,20,300,315,90);
	loop(400) {
		cometX = ObjMove_GetX(Comet);
		cometY = ObjMove_GetY(Comet);
		count++;
		wait(1);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) == 0) {Obj_Delete(Comet);}
		ObjMove_SetPosition(las,cometX,cometY);
		if (count == 400) {Obj_Delete(Comet);}
	}	
}

task fadeout(obj) {
	wait(90);
	ObjShot_FadeDelete(obj);
}

task PlaySoundInSingle(name){
 NotifyEvent(GetCommonData("MarisaBossPlural.cs", ID_INVALID), EV_USER+20, name);
}

function Laser_Collider(x, y, angle, l_length,width, delete_time, graphic,delay) //Thanks Ultima!
{
 if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
 let obj = CreateStraightLaserA1(x,y,angle,l_length,width,delete_time,graphic,delay);
 ObjLaser_SetInvalidLength(obj,0,0);
 if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
 PlaySoundInSingle("se_shot_laser");
task Collaser (obj){
 while(!Obj_IsDeleted(obj))
 {
  let collided_bullets = [];
  
  ascent(i in 0..50)
  {
   let rad = 10*i;
   collided_bullets = collided_bullets ~GetShotIdInCircleA2(ObjMove_GetX(obj)+rad*cos(angle),ObjMove_GetY(obj)+rad*sin(angle),5,TARGET_ENEMY);
  }
  
  ascent(i in 0..length(collided_bullets))
  {
   if(Obj_GetValueD(collided_bullets[i],"Collide Laser",false) && (Obj_GetType(collided_bullets[i])==OBJ_SHOT)) //why False?
   {
	let CBX = ObjMove_GetX(collided_bullets[i]); //can I do this?
	let CBY = ObjMove_GetY(collided_bullets[i]);
	PlaySoundInSingle("se_shot_kira00");
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
    ascent(j in 0..3) {
			CreateShotA1(CBX,CBY,1.5-(j*0.1),GetAngleToPlayer(collided_bullets[i]),147,30);
   }
   if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
   ObjShot_SetGraphic(collided_bullets[i],44);
   ObjMove_SetSpeed(collided_bullets[i],0.5);
   Obj_SetValue(collided_bullets[i],"Collide Laser",false); //Placement on this ok?
  }
	
 }
 yield;
}

}
Collaser(obj);
return obj;
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(Boss);
	loop(81) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}