#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaSpell2"]
#Text["Contest Marisa's second spell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"
#include"./GTcutin.txt"

//Stargazing "Past view from the present"
let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let ImageFam = GetCurrentScriptDirectory ~ "IMG/Familiar.png";
let ImageSpellBG = GetCurrentScriptDirectory ~ "IMG/Hakkero3.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;
let fam = [];
let around = rand(0,1);
let FR = floor(rand(1,3+1));



@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	SpellBG;
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjCutin_SetSpellcardS3("Stargazing \"Past View From the Present\"", 128, 128, 128);
	ObjCutin_LaunchS3("NAZRIN",GetCurrentScriptDirectory~"IMG/DairiMarisa.png","Lunatic");
	Spell;
	ObjTempInv(Boss,200);
	FamAndPath6;
	Ending;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(3500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(90);
	}
	
	case(EV_REQUEST_SPELL_SCORE) {
		SetScriptResult(80000);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	Timing++;
	
		if (Timing == 200) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4+rand(-80,10),rand(60,100),15,7); 
		Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0); FR = floor(rand(1,3+1)); firerandom(fam[0],FR);}
	if (Timing == 400) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4*3+rand(10,80),rand(60,100),15,7); FR = floor(rand(1,3+1)); firerandom(fam[2],FR); 
		around = rand(0,1); if (around >= 0.5) {Warnlaserlink(fam[1],fam[2],80,0);  
		Warnlaserlink(Boss,fam[0],80,0);} else {Warnlaserlink(fam[0],fam[1],80,0);  Warnlaserlink(Boss,fam[2],80,0);}}
	
	if (Timing == 600) {if (around >= 0.5) {around1;} else {around2;}}
	if (Timing == 1000) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4+rand(-80,10),rand(60,100),15,7); FR = floor(rand(1,3+1)); firerandom(fam[0],FR); 
		around = rand(0,1); if (around >= 0.5) {Warnlaserlink(Boss,fam[2],80,0); 
		Warnlaserlink(fam[0],fam[1],80,0);} else{Warnlaserlink(fam[1],fam[2],80,0);  Warnlaserlink(Boss,fam[0],80,0);}}
	if (Timing == 1200) {if (around <= 0.5) {around3;} else {around4;}}
	
	if (Timing == 1600) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4*3+rand(10,80),rand(60,100),15,7); fireMarisa(Boss);}
	
	if (Timing == 1800) {enclose;}
	if (Timing == 2430) {Timing = 0;}
	
	yield;

}

task ObjTempInv(Obj,time) {
	ObjEnemy_SetDamageRate(Obj,0,0);
	wait(time);
	ObjEnemy_SetDamageRate(Obj,80,50);
}

function wait(w) { loop(w) { yield; } }

task Spell {
let objScene = GetEnemyBossSceneObjectID;
ObjEnemyBossScene_StartSpell(objScene);
}

task SpellBG {
	let SpellBGobj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(SpellBGobj,ImageSpellBG);
	ObjSprite2D_SetSourceRect(SpellBGobj,0,0,800,800);
	ObjSprite2D_SetDestRect(SpellBGobj,0,0,800,800);
	Obj_SetRenderPriorityI(SpellBGobj,22);
	ObjSprite2D_SetDestCenter(SpellBGobj); 
	ObjRender_SetPosition(SpellBGobj,GetStgFrameWidth/2,GetStgFrameHeight/2,0);
	let count = 0;
	ObjRender_SetAlpha(SpellBGobj,128);
	ObjRender_SetScaleXYZ(SpellBGobj,0.6,0.6,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=0.5;
		ObjRender_SetAngleZ(SpellBGobj,-count);
		yield;
		if (count == 360) {count = 0; }
	}
	Obj_Delete(SpellBGobj);
 }
 
task PlaySoundInSingle(name){
	NotifyEvent(GetCommonData("MarisaBossPlural.cs", ID_INVALID), EV_USER+20, name);
}

task RenderMarisa {
let dir;
let speed;

ObjPrim_SetTexture(Boss,ImageBoss);
ObjSprite2D_SetDestCenter(Boss); 
ObjRender_SetScaleXYZ(Boss,1,1,0);
MagicCircle;

ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
ObjAnim_StartAnimationA1(Boss, 5, 3);
}
 
task MagicCircle{
	wait(1);
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
	Obj_Delete(Circle);
}
 
task RotateImg(obj,speed) {
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=speed;
		ObjRender_SetAngleZ(obj,count);
		if (count == speed*360) {count = 0;}
		yield;
	}
}

task FamAndPath6 { //Creates 3 familiars and controls their movement
	wait(120);
	PlaySoundInSingle("se_effect_glub");
	let count = 0;
	ascent(m in 0..3) { //number of familiars, and number to add to the array
		fam = append(fam,ObjEnemy_Create(OBJ_ENEMY));
        ObjMove_SetPosition(fam[m],BossX,BossY);
        ObjPrim_SetTexture(fam[m],ImageFam);
        ObjSprite2D_SetSourceRect(fam[m],0,0,72,72);
        ObjSprite2D_SetDestCenter(fam[m]);
        ObjEnemy_Regist(fam[m]);
		ObjRender_SetScaleXYZ(fam[m],0.6,0.6,0);
		RotateImg(fam[m],3);
		
	}
	wait(1);
	let incr = 30;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=1;
		if (incr >= 1) {incr -=0.3;}
		ObjMove_SetDestAtWeight(fam[0],BossX,GetStgFrameHeight-BossY,incr,30);
		ObjMove_SetDestAtWeight(fam[1],GetStgFrameWidth-BossX,GetStgFrameHeight-BossY,incr,30);
		ObjMove_SetDestAtWeight(fam[2],GetStgFrameWidth-BossX,BossY,incr,30);

		wait(1);
		if (count == 720) {count = 0}
	}
	ascent(i in 0..3) {Obj_Delete(fam[i]);}
}

task fire1(obj) {
	wait(80);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	let dir = 0;
	let flip = 0;
	let variety = rand(0,360);
	let changedir = rand(0,1);
	let change = 0;
	let count = 0;
	loop(20) {
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
		if (changedir >= 0.5) {change = 360/20;} 
		else {change = -360/20;}
		dir+=change;
		count+=1;
		PlaySoundInSingle("se_shot_tan00");
		ascent(i in 0..3) {
			let objX = ObjMove_GetX(obj);
			let objY = ObjMove_GetY(obj);
			flip = 0;
			loop(2) {
				CreateShotA1(objX,objY,0.5+(i*0.3),dir+flip+variety+count,126,10);
				flip = 180;
			}
		}
		wait(5);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task fire2(obj) {
	wait(80);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	let dir = 0;
	let variety = rand(0,360);
	ascent(i in 0..6){
		PlaySoundInSingle("se_shot_tan02");
		loop(13) {
			
			dir+=360/13;
			let objX = ObjMove_GetX(obj);
			let objY = ObjMove_GetY(obj);
			CreateShotA1(objX,objY,2-(i*0.3),dir+variety,100,10);
		}
		wait(10);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task fire3(obj) {
		wait(80);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
		let dir = 0;
		let variety = rand(0,360);
		let changedir = rand(0,1);
		let change = 0;
		let count = 0;
		loop(87) {
			PlaySoundInSingle("se_shot_tan01");
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
			if (changedir >= 0.5) {change = 27;} 
			else {change = -27;}
			count+=0.02;
			dir+=change;
			let objX = ObjMove_GetX(obj);
			let objY = ObjMove_GetY(obj);
			CreateShotA1(objX,objY,2-count*0.9,dir+variety,18,10);
			wait(1);
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
		}
}

task fireMarisa(obj) {
//Boss: So Ms. Kirisame, I hear you've been stealing from your fellow employees.
//Marisa: What? They're saying such things? No, no, I'm just borrowing from them, ze!
//Boss: "Borrowing"?
//Marisa: Yeah, I'll return their stuff once I'm done with it.
//Boss: ...And when will that be?
//Marisa: Ooh, that's a tough question to answer, ze... ...Tell ya what, when I die to a bullet, I'll swing by and give their things back.
//Boss: ..............You're fired.
//LATER
//Marisa: What was his deal? I thought that was a pretty good offer!
	wait(80);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	ObjAnim_SetAttackA2(Boss,60);
	let objX = ObjMove_GetX(obj);
	let objY = ObjMove_GetY(obj);
	let aim = GetAngleToPlayer(obj);
	let split = -30;
	loop(3) {
		objX = ObjMove_GetX(obj);
		objY = ObjMove_GetY(obj);
		ascent(i in 0..10) {
			CreateShotA2(objX,objY,1-(i*0.5),aim+split,0.05,2,42,10);
			
		}
	split+=30;
	}
	PlaySoundInSingle("se_shot_kira00");
	loop(20) {
		objX = ObjMove_GetX(obj);
		objY = ObjMove_GetY(obj);
			CreateShotA2(objX,objY,0,aim+rand(-50,50),0.05,rand(0.5,1.5),42,10);
	}
}

task around1 {
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4*3+rand(10,80),rand(380,420),15,7); 
Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
FR = floor(rand(1,3+1)); firerandom(fam[1],FR);
wait(200); 
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4+rand(-80,10),rand(380,420),15,7); 
Warnlaserlink(fam[1],fam[2],80,0);  Warnlaserlink(Boss,fam[0],80,0);
fireMarisa(Boss);
}

task around2 {
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4+rand(-80,10),rand(60,100),15,7); 
Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
FR = floor(rand(1,3+1)); firerandom(fam[2],FR);
wait(200); 
Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4*3+rand(10,80),rand(60,100),15,7);
fireMarisa(Boss);
}

task around3 {
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4+rand(-80,10),rand(380,420),15,7); 
Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
FR = floor(rand(1,3+1)); firerandom(fam[2],FR);
wait(200); 
Warnlaserlink(fam[1],fam[2],80,0);  Warnlaserlink(Boss,fam[0],80,0);
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4*3+rand(10,80),rand(380,420),15,7); 
FR = floor(rand(1,3+1)); firerandom(fam[1],FR);
}

task around4 {
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4*3+rand(10,80),rand(60,100),15,7); 
Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
FR = floor(rand(1,3+1)); firerandom(fam[2],FR);
wait(200); 
Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/4+rand(-80,10),rand(60,100),15,7);
FR = floor(rand(1,3+1)); firerandom(fam[1],FR);
}

task around5 {
let randatk = floor(rand(1,5));
firerandom(fam[0],randatk);
firerandom(fam[2],randatk);
firerandom(fam[1],randatk);
firerandom(Boss,randatk);
}

task firerandom(obj,number){
if (number == 1) {fire1(obj);}
if (number == 2) {fire2(obj);}
if (number == 3) {fire3(obj);}
if (number == 4) {fireMarisa(obj);}
if (number == 5) {ObjAnim_SetAttackA2(Boss,30);}
}

task Warnlaserlink(obj1,obj2,time,twait) {
wait(130+twait);
if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
let laser;
let X1 = ObjMove_GetX(obj1);
let Y1 = ObjMove_GetY(obj1);
let X2 = ObjMove_GetX(obj2);
let Y2 = ObjMove_GetY(obj2);
let dir = atan2(Y1-Y2,X1-X2);
let	dir2 = atan2(Y2-Y1,X2-X1);
let dist = ((Y2-Y1)^2+(X2-X1)^2)^0.5;
laser = CreateStraightLaserA1(X1,Y1,dir2,dist,20,10,315,time);
delframe(laser,time-5);
laser = CreateStraightLaserA1(X2,Y2,dir,dist,20,10,315,time);
delframe(laser,time-5);
}

task delframe(obj,time){
	wait(time);
	Obj_Delete(obj);
}

task laserlink(obj1,obj2) {
	let laser1;
	let laser2;
	let X1 = ObjMove_GetX(obj1);
	let Y1 = ObjMove_GetY(obj1);
	let X2 = ObjMove_GetX(obj2);
	let Y2 = ObjMove_GetY(obj2);
	let dir = atan2(Y1-Y2,X1-X2);
	let	dir2 = atan2(Y2-Y1,X2-X1);
	let dist = ((Y2-Y1)^2+(X2-X1)^2)^0.5;
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	laser1 = CreateStraightLaserA1(X1,Y1,dir2,dist,20,600,315,90);
	laser2 = CreateStraightLaserA1(X2,Y2,dir,dist,20,600,315,90);
	wait(1);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	PlaySoundInSingle("se_shot_laser");
	loop (600) {
		X1 = ObjMove_GetX(obj1);
		Y1 = ObjMove_GetY(obj1);
		X2 = ObjMove_GetX(obj2);
		Y2 = ObjMove_GetY(obj2);
		dir = atan2(Y1-Y2,X1-X2);
		dir2 = atan2(Y2-Y1,X2-X1);
		dist = ((Y2-Y1)^2+(X2-X1)^2)^0.5;
		ObjLaser_SetLength(laser1,dist);
		ObjMove_SetPosition(laser1,X1,Y1);
		ObjLaser_SetLength(laser2,dist);
		ObjMove_SetPosition(laser2,X2,Y2);
		wait(1);
	}
}

task enclose {
	wait(5);
	ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth-10,10,50,15);
	wait(75);
	laserlink(Boss,fam[0]); 
	laserlink(Boss,fam[2]); 
	laserlink(fam[1],fam[0]); 
	laserlink(fam[1],fam[2]);
	wait(80);
	around5;
	wait(80);
	PlaySoundInSingle("se_effect_weird2");
	wait(40);
	ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2+45,GetStgFrameHeight/2-45,100,50);
	wait(350);
	ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth-30,+30,30,15);
	Warnlaserlink(Boss,fam[2],80,0); Warnlaserlink(fam[0],fam[1],80,0);
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(Boss);
	loop(81) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}