#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["MarisaSpell3"]
#Text["Contest Marisa's third spell"]

#include"./CustShot/AchyShot_Const.cs"
#include"./animlib.h"
#include"./GTcutin.txt"


//Passion sign "Master Flare"
let Boss;
let ImageBoss = GetCurrentScriptDirectory ~ "IMG/Marisa.png";
let ImageMC = GetCurrentScriptDirectory ~ "IMG/MagicCircle.png";
let Timing = 0;
let BossX = 0;
let BossY = 0;
let ImageSpark = GetCurrentScriptDirectory ~ "IMG/FireSpark.png";
let ImageSparkFire = GetCurrentScriptDirectory ~ "IMG/FlareRing.png";
let ImageSpellBG = GetCurrentScriptDirectory ~ "IMG/Hakkero3.png";
let Warm = GetCurrentScriptDirectory ~ "IMG/Heat.png";
let Spark;
let Heat;
Spark = ObjPrim_Create(OBJ_SPRITE_2D);
ObjPrim_SetTexture(Spark,ImageSpark);
Heat = ObjPrim_Create(OBJ_SPRITE_2D);
ObjPrim_SetTexture(Heat,Warm);
ObjSprite2D_SetSourceRect(Heat,0,0,800,800);
ObjSprite2D_SetDestCenter(Heat);
ObjSprite2D_SetDestRect(Heat,-50,-50,GetStgFrameWidth+50,GetStgFrameHeight+50);
ObjRender_SetAlpha(Heat,0);

@Initialize {
	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	SpellBG;
	RenderMarisa; //thanks Phantomsong and GT
	DeleteShotAll(TYPE_ALL,TYPE_ITEM);
	ObjCutin_SetSpellcardS3("Passion Sign \"Master Flare\"", 255, 128, 0);
	ObjCutin_LaunchS3("NAZRIN",GetCurrentScriptDirectory~"IMG/DairiMarisa.png","Lunatic");
	Spell;
	ObjTempInv(Boss,200);
	ObjMove_SetDestAtFrame(Boss,GetStgFrameWidth/2,100,60);
	
	Ending;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(4500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(70);
	}
	
	case(EV_REQUEST_SPELL_SCORE) {
		SetScriptResult(70000);
	}

}

@MainLoop {
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,20);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,20);
	Timing++;
	yield;
	if (Timing == 150) {FSpark(GetAngleToPlayer(Boss));}
	if (Timing == 580) {ObjMove_SetDestAtWeight(Boss,rand(GetStgFrameWidth/4-40,GetStgFrameWidth/4+40),rand(80,120),10,10);}
	if (Timing == 750) {Marisafire1;}
	if (Timing == 1150) {FSpark(GetAngleToPlayer(Boss));}
	if (Timing == 1580) {ObjMove_SetDestAtWeight(Boss,rand(GetStgFrameWidth/4*3-40,GetStgFrameWidth/4*3+40),rand(80,120),10,10);}
	if (Timing == 1750) {Marisafire2;}
	if (Timing == 2050) {Timing = 50;}
}

task Spell {
let objScene = GetEnemyBossSceneObjectID;
ObjEnemyBossScene_StartSpell(objScene);
}

function wait(w) { loop(w) { yield; } }

task ObjTempInv(Obj,time) {
	ObjEnemy_SetDamageRate(Obj,0,0);
	wait(time);
	ObjEnemy_SetDamageRate(Obj,80,50);
}

task RenderMarisa {
let dir;
let speed;

ObjPrim_SetTexture(Boss,ImageBoss);
ObjSprite2D_SetDestCenter(Boss); 
ObjRender_SetScaleXYZ(Boss,1,1,0);
MagicCircle;

ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
descent(x in 0..2){ObjAnim_AddFrameA1(Boss, ANIM_IDLE, 64*x, 0, 64*(x+1), 80);}
 
ascent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVE, 64*x, 80, 64*(x+1), 160);}
descent(x in 0..4){ObjAnim_AddFrameA1(Boss, ANIM_MOVEEND, 64*x, 80, 64*(x+1), 160);}

ObjAnim_AddFrameA1(Boss, ANIM_ATTACK, 64, 160, 1, 240);
ObjAnim_AddFrameA1(Boss, ANIM_ATTACKEND, 64, 160, 1, 240);

ObjAnim_SetLoopPointA1(Boss, ANIM_MOVE, 3);
ObjAnim_SetLoopPointA1(Boss, ANIM_ATTACK, 0);
ObjAnim_SetSpeedA1(Boss, ANIM_IDLE, 12);
ObjAnim_SetSpeedA1(Boss, ANIM_MOVE, 5);
ObjAnim_SetSpeedA1(Boss, ANIM_ATTACK, 8);
ObjAnim_StartAnimationA1(Boss, 5, 3);
}

task SpellBG {
	let SpellBGobj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(SpellBGobj,ImageSpellBG);
	ObjSprite2D_SetSourceRect(SpellBGobj,0,0,800,800);
	ObjSprite2D_SetDestRect(SpellBGobj,0,0,800,800);
	Obj_SetRenderPriorityI(SpellBGobj,22);
	ObjSprite2D_SetDestCenter(SpellBGobj); 
	ObjRender_SetPosition(SpellBGobj,GetStgFrameWidth/2,GetStgFrameHeight/2,0);
	let count = 0;
	ObjRender_SetAlpha(SpellBGobj,128);
	ObjRender_SetScaleXYZ(SpellBGobj,0.6,0.6,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=0.5;
		ObjRender_SetAngleZ(SpellBGobj,-count);
		yield;
		if (count == 360) {count = 0; }
	}
	Obj_Delete(SpellBGobj);
 }
 
task MagicCircle{
	wait(1);
	let Circle = ObjPrim_Create(OBJ_SPRITE_2D);
	let count = 0;
	ObjPrim_SetTexture(Circle,ImageMC);
	ObjSprite2D_SetSourceRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestRect(Circle,0,0,128,128);
	ObjSprite2D_SetDestCenter(Circle); 
	ObjRender_SetScaleXYZ(Circle,1,1,0);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		count+=2;
		ObjRender_SetPosition(Circle,BossX,BossY,0);
		ObjRender_SetAngleZ(Circle,count);
		yield;
	}
	Obj_Delete(Circle);
}

task FSpark(aim) {
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	let start = CreateStraightLaserA1(BossX,BossY,aim,600,20,40,306,90);
	wait(80);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	ObjAnim_SetAttackA2(Boss,270);
	ObjRender_SetPosition(Spark,BossX,BossY,0);
	ObjRender_SetAngleZ(Spark,aim-90);
	ObjSprite2D_SetSourceRect(Spark,0,0,258,514);
	ObjSprite2D_SetDestCenter(Spark);
	ObjSprite2D_SetDestRect(Spark,-128,0,128,512);
	let hitbox = CreateStraightLaserA1(BossX,BossY,aim,600,350,350,306,20);
	ObjLaser_SetInvalidLength(hitbox,0,0);
	ObjLaser_SetRenderWidth(hitbox,0);
	let wid = 0;
	let opa = 0;
	Backfire(Spark);
	Sidefire(Spark);
	Midfire(Spark);
	Obj_SetRenderPriorityI(Heat,52);
	Obj_SetRenderPriorityI(Spark,53);
	ImageFlipHor(Spark,0,0,258,514,2);
	PlaySoundInSingle("se_player_bomb");
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
	loop(20) {
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
	wid +=0.05;
	opa+=255/20;
		ObjRender_SetScaleX(Spark,wid);
		ObjRender_SetAlpha(Spark,opa);
		wait(1);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
		ScreenShakeA1(20,5);
	}
	Opascaleup(Heat,100,0.9);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
	loop(25){
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
		SparkRipple(Spark);
		wait(13);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
		ScreenShakeA1(15,8);
	}
	Opascaledown(Heat,100,0.6);
	wait(10);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
	loop(10) {
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
		ScreenShakeA1(30,2);
		wid -=0.1;
		opa	-=255/10;
		ObjRender_SetScaleX(Spark,wid);
		ObjRender_SetAlpha(Spark,opa);
		wait(1);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
	}
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
	wait(300);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Spark); Obj_Delete(Heat);}
}

task SparkRipple(obj) {
	let Ripple = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(Ripple,ImageSparkFire);
	ObjSprite2D_SetSourceRect(Ripple,0,0,256,128);
	ObjSprite2D_SetDestCenter(Ripple);
	Obj_SetRenderPriorityI(Ripple,54);
	let opa = 0;
	let wid = 0;
	let hig = 0;
	let slide = 0;
	while (!Obj_IsDeleted(Ripple)){
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {Obj_Delete(Ripple);}
		if (opa <= 255) {opa+=25;}
		if (wid <=1.05) {wid +=0.06;}
		if (hig <=1.5) {hig +=0.07;}
		slide+=15;
		ObjRender_SetScaleX(Ripple,wid);
		ObjRender_SetScaleY(Ripple,hig);
		ObjRender_SetAlpha(Ripple,opa);
		let objX = ObjRender_GetX(obj);
		let objY = ObjRender_GetY(obj);
		let objang = ObjRender_GetAngleZ(obj);
		ObjRender_SetPosition(Ripple,objX+slide*cos(objang+90),objY+slide*sin(objang+90),objang);
		ObjRender_SetAngleZ(Ripple,objang);
		wait(1);
		if (slide >= 600) {Obj_Delete(Ripple);}
		if (Obj_IsDeleted(obj)) {Obj_Delete(Ripple);}
	}
	
}

task ImageFlipHor(obj,r,e,c,t,speed) {
	while(!Obj_IsDeleted(obj)) {
		ObjSprite2D_SetSourceRect(obj,r,e,c,t);
		wait(speed);
		ObjSprite2D_SetSourceRect(obj,r,e,-c,t);
		wait(speed);
	}
}

task delframe(obj,time){
	wait(time);
	Obj_Delete(obj);
}

task ScreenShakeA1(shaketime, intensity){ //Thanks Lunar!
        while(shaketime>0){
                Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-intensity, intensity));
                Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-intensity, intensity));
                shaketime--;
                yield;
        }
        Reset2DCamera;
        yield;
}

task PlaySoundInSingle(name){
NotifyEvent(GetCommonData("MarisaBossPlural.cs", ID_INVALID), EV_USER+20, name);
}

task Opascaleup(obj,max,speed) {
	let opa = 0;
	while (opa <=max) {
		if (opa <= max) {opa+=speed;}
		ObjRender_SetAlpha(obj,opa);
		wait(1);
	}
}

task Opascaledown(obj,max,speed) {
	let opa = max;
	while (opa >= 0) {
		if (opa >= 0) {opa-=speed;}
		ObjRender_SetAlpha(obj,opa);
		wait(1);
	}
}

task Backfire(obj) {
	wait(10);
	loop(330) {
		PlaySoundInSingle("se_shot_tan02");
		loop(5) {
			CreateShotA2(BossX,BossY,1,ObjRender_GetAngleZ(obj)-90+rand(-115,115),0.05,rand(4,5),rand(274,276),10);
		}
		wait(1);
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task Sidefire(obj) {
	wait(20);
	let objZ = ObjRender_GetAngleZ(obj);
	let dir = 0;
	loop(10) {	
		let slide = rand(10,30);
		loop(30) {
		if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
			slide+=30;
			dir = objZ+rand(-10,10);
			loop(2) {
				CreateShotA2(BossX+slide*cos(objZ+90),BossY+slide*sin(objZ+90),4,dir,-0.07,1.5,274,0);
				dir = ObjRender_GetAngleZ(obj)+180+rand(-10,10);
			}
			slide+=30;
			dir = objZ;
			loop(2) {
				CreateShotA2(BossX+slide*cos(objZ+90),BossY+slide*sin(objZ+90),4,dir,-0.07,1.5,275,0);
				dir = ObjRender_GetAngleZ(obj)+180;
			}
		}
	wait(35);
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task Midfire(obj){
	wait(350);
	let objZ = ObjRender_GetAngleZ(obj)+90;
	let dir = rand(0,360);
	PlaySoundInSingle("se_shot_tan01");
	loop(4) {
		let slide = 30;
		loop(40){
			slide+=26;
			dir+=33;
			ascent(i in 0..3) {
				dir+=11.4;
				CreateShotA2(BossX+slide*cos(objZ),BossY+slide*sin(objZ),0,dir,0.07-(i*0.05),1.3-(i*0.4),274+i,0);
				CreateShotA2(BossX+slide*cos(objZ),BossY+slide*sin(objZ),0,dir,0.07-(i*0.05),1.3-(i*0.4),35+i,0);
			}
		}
	}
}

task Marisafire1 {
	let change = 0;
	let dir = rand(0,90);
	let spd = 0;
	loop(13) {
		PlaySoundInSingle("se_shot_tan00");
		spd+=0.1;
		dir+=11.25/2;
		loop(32){
			dir+=360/32;
			change++;
			CreateShotA2(BossX,BossY,0.5,dir,0.02,1.7+spd,272+change,20);
			CreateShotA2(BossX,BossY,0.5,dir,0.02,1.7+spd,33+change,20);
			if (change == 4) {change = 0;}
		}
	wait(35-(spd*10));
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task Marisafire2 {
	let change = 0;
	let dir = rand(0,90);
	let spd = 0;
	let largefire;
	loop(13) {
		PlaySoundInSingle("se_shot_tan01");
		spd+=0.1;
		dir+=45;
		loop(28){
			dir+=360/28;
			change++;
			largefire = CreateShotA2(BossX,BossY,0.5,dir,0.02,1.7+spd,272+change,20);
			ObjRender_SetScaleXYZ(largefire,2,2,0);
			CreateShotA2(BossX,BossY,0.5,dir,0.02,1.7+spd,99+change,20);
			if (change == 4) {change = 0;}
		}
	wait(35-(spd*10));
	if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 0) {return;}
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	SetAutoDeleteObject(true);
	Obj_Delete(Boss);
	Obj_Delete(Spark);
	Obj_Delete(Heat);
	loop(81) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}